<template>
  <section class="section-events container">
    <h1>Купленные билеты</h1>
    <p>Не забудьте взять с собой паспорт</p>
    <template v-if="isAdmin">
      <p>Фильтр по типу:
        <label v-for="eventType in eventTypes" :key="eventType" class="me-2"><input type="checkbox" :value="eventType" v-model="filteredEventTypes">
          {{ eventType }}</label>
      </p>
      <p><label>Поиск по email пользователя: <label><input style="outline: none;" type="search" v-model="userEmail"></label></label></p>
    </template>
    <p v-if="tickets && !tickets.length">У вас пока их нет, перейдите на <router-link to="/">страницу афиши</router-link>, выберите событие и купите на него билет внизу страницы</p>
    <template v-else>
      <p>Куплено билетов: {{this.ticketsAmount}}</p>
      <ul class="events list-unstyled">
        <li class="event" v-for="{count, event_data, user_data, id} in tickets" :key="id" v-if="filteredEventTypes.includes(event_data.type) && user_data.email.toLowerCase().includes(userEmail.toLowerCase())">
          <router-link :to="'/events/' + event_data.id" class="position-relative mb-3">
            <img class="event__image img-fluid" :src="'http://localhost:8000' + event_data.cover" :alt="event_data.title">
            <span class="event__type">{{event_data.type}}</span>
          </router-link>
          <p class="event__title">{{event_data.title}}</p>
          <p class="mt-auto">Место: {{event_data.place}}</p>
          <p>Начало: {{event_data.begins_at | formatEventDate}}</p>
          <p class="fw-bold">Количество купленных билетов: {{count}}</p>
          <p v-if="isAdmin">{{user_data.email}}</p>
          <button v-if="isAdmin" class="btn btn-danger border-radius" @click="deleteTicket(id)" type="button">Удалить</button>
          <router-link v-else class="btn btn-primary border-radius" :to="'/events/' + event_data.id">Подробнее</router-link>
        </li>
      </ul>
    </template>
  </section>
</template>

<script>
import axios from "axios";

export default {
  name: "Tickets",
  data() {
    return {
      tickets: null,
      filteredEventTypes: [],
      userEmail: '',
      isAdmin: false,
      ticketsAmount: null
    }
  },
  created() {
    this.fetchTickets()
  },
  methods: {
    fetchTickets() {
      axios.get('events/tickets/')
          .then(({data: {tickets, isAdmin, count__sum}}) => {
            this.tickets = tickets
            this.filteredEventTypes = [...new Set(tickets.map(ticket => ticket.event_data.type))]
            this.isAdmin = isAdmin
            this.ticketsAmount = count__sum
          })
    },
    deleteTicket(ticketId) {
      axios
          .delete(`events/${ticketId}/tickets/`)
          .then(() => {
            this.fetchTickets()
          })
    }
  },
  /*computed: {
    events() {
      console.log(this.tickets && this.tickets.map(ticket => ticket.event_data))
      return this.tickets && this.tickets.map(ticket => ticket.event_data)
    }
  },*/
  computed: {
    eventTypes() {
      return [...new Set(this.tickets.map(ticket => ticket.event_data.type))]
    }
  },
  filters: {
    formatEventDate(date) {
      const formatter = new Intl.DateTimeFormat("ru", {
        weekday: "short",
        month: "long",
        day: "2-digit",
        year: "numeric",
        hour: "2-digit",
        minute: "2-digit",
      });
      return date && formatter.format(new Date(date))
    }
  },
}
</script>

<style scoped>
.border-radius {
  border-radius: 9px;
}

</style>